"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringify = void 0;
var significantFields_1 = require("./significantFields");
/**
 * @access private
 */
function stringify(v) {
    if (Array.isArray(v)) {
        return "".concat(v.constructor.name, "(").concat(v.map(function (i) { return stringify(i); }).join(', '), ")");
    }
    if (v instanceof Date) {
        return v.toISOString();
    }
    if (isObject(v)) {
        var fields = (0, significantFields_1.significantFieldsOf)(v)
            .map(function (field) { return ({ field: field, value: stringify(v[field]) }); })
            .reduce(function (acc, current) {
            return acc.concat("".concat(current.field, "=").concat(current.value));
        }, []);
        return "".concat(v.constructor.name, "(").concat(fields.join(', '), ")");
    }
    return String(v);
}
exports.stringify = stringify;
function isObject(value) {
    return new Object(value) === value;
}
//# sourceMappingURL=stringify.js.map