"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PatternMatcher = void 0;
var rules_1 = require("./rules");
/**
 * @access private
 */
var PatternMatcher = /** @class */ (function () {
    function PatternMatcher(value, rules) {
        if (rules === void 0) { rules = []; }
        this.value = value;
        this.rules = rules;
    }
    PatternMatcher.prototype.else = function (transformation) {
        var _this = this;
        var matching_rule = this.rules.find(function (m) { return m.matches(_this.value); });
        return (matching_rule || new rules_1.MatchesAnything(transformation)).execute(this.value);
    };
    return PatternMatcher;
}());
exports.PatternMatcher = PatternMatcher;
//# sourceMappingURL=PatternMatcher.js.map